#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

int errno;

void error_exit(int rc,char *msg) {
	if ( errno )
        	perror(msg);
	else
		printf("%s\n",msg);
        exit(rc);
}

int findoffset(int fd, char *findval, int count) {

        char buf[4096];
	int i,j,bc,offset;

	if ( lseek(fd,0,SEEK_SET) != 0 )
		error_exit(1,"Seeking in player executable");
	j=bc=0;
	while ( read(fd, buf, 4096) > 0 ) {
		for (i=0;i<4096;i++) {
			if ( buf[i] == findval[j] ) {
				if ( j == 0 )
					offset=(bc*4096) + i;
				j++;
				if ( j == count )
					return offset;
			} else j=0;
		}
		bc++;
	}
}

int main(int argc, char *argv[])
{
        int ifd,pfd,lfd,playersize,primsize;
        struct stat *fdstat;
        char buf[4100];
        char nbuf[4224];
	char answer[1024];
        int i,j,k,e;
        int x,y;

 
        pfd = open("/empeg/bin/player", O_RDWR);
        if ( pfd == -1 )
		error_exit(1,"Opening player executable");

//MT        lfd = open("/empeg/lib/primitives.bin", O_RDWR);
//MT       if ( lfd == -1 )
//MT		error_exit(1,"Opening visualization library");
//MT
        fdstat=(struct stat *) malloc( sizeof(struct stat) );

        if ( fstat(pfd,fdstat) == -1 )
		error_exit(1,"/empeg/bin/player");
	playersize=fdstat->st_size;

//MT        if ( fstat(lfd,fdstat) == -1 )
//MT		error_exit(1,"/empeg/lib/primitives.bin");
//MT	primsize=fdstat->st_size;

// static visualization image

	i=findoffset(pfd," .Xo                                            ",48);
	i+=128;
	if ( ((i+4224) > playersize) || (i<1) ) {
		printf("wrong offset: %d\n",i);
		error_exit(1,"");
		}
	printf("found static visual bitmap at offset %d; replace? [Y/N] ",i);
	if ( fgets(answer,1024,stdin) != NULL ) 
		if ( answer[0] == 'Y' || answer[0] == 'y' ) {
			if ( lseek(pfd,i,SEEK_SET) != i )
				error_exit(1,"Seeking in player executable");
			printf("bitmap filename : ");
			if ( fgets(answer,1024,stdin) != NULL ) {
				answer[strlen(answer)-1]='\0';
        			ifd = open(answer, O_RDONLY);
        			if ( ifd == -1 )
					error_exit(1,answer);
        			if ( fstat(ifd,fdstat) == -1 )
					error_exit(1,answer);
				if ( fdstat->st_size != 4100 )
					error_exit(1,"file incorrect size");
	
				if ( read(ifd, buf, 4100) != 4100)
					error_exit(1,answer);
        			close(ifd);
				e=0;
				for (i=0;i<32;i++) {
					for(j=0;j<4;j++)
						nbuf[e++] = '\0';
					for (j=0;j<64;j++) {
						x=buf[4+j+(i*64)] & 15;
						y=(buf[4+j+(i*64)] >> 4) & 15;
						switch (x) {
						case 0: nbuf[e++]=' ';break;
						case 1: nbuf[e++]='.';break;
						case 2: nbuf[e++]='X';break;
						case 3: nbuf[e++]='o';break;
						default: nbuf[e++]=' ';
						}
						switch (y) {
						case 0: nbuf[e++]=' ';break;
						case 1: nbuf[e++]='.';break;
						case 2: nbuf[e++]='X';break;
						case 3: nbuf[e++]='o';break;
						default: nbuf[e++]=' '; 
						}
					}
				}
				if ( write(pfd, nbuf, 4224) != 4224 )
				error_exit(1,"modifying player executable");
				printf("written static visual\n");
			}

		}

// logo-image



	i=findoffset(pfd," .o#                                            ",48);
	i+=52;
	if ( ((i+896) > playersize) || (i<1) ) {
		printf("wrong offset: %d\n",i);
		error_exit(1,"");
		}
	printf("found startup-logo bitmap at offset %d; replace? [Y/N] ",i);
	if ( fgets(answer,1024,stdin) != NULL ) 
		if ( answer[0] == 'Y' || answer[0] == 'y' ) {
			if ( lseek(pfd,i,SEEK_SET) != i )
				error_exit(1,"Seeking in player executable");
			printf("bitmap filename : ");
			if ( fgets(answer,1024,stdin) != NULL ) {
				answer[strlen(answer)-1]='\0';
        			ifd = open(answer, O_RDONLY);
        			if ( ifd == -1 )
					error_exit(1,answer);
        			if ( fstat(ifd,fdstat) == -1 )
					error_exit(1,answer);
				if ( fdstat->st_size != 4100 )
					error_exit(1,"file incorrect size");
	
				if ( read(ifd, buf, 4100) != 4100)
					error_exit(1,answer);
        			close(ifd);
				e=0;
				for (i=0;i<16;i++) {
					for(j=0;j<4;j++)
						nbuf[e++] = '\0';
					for (j=0;j<26;j++) {
						x=buf[4+j+(i*64)] & 15;
						y=(buf[4+j+(i*64)] >> 4) & 15;
						switch (x) {
						case 0: nbuf[e++]=' ';break;
						case 1: nbuf[e++]='.';break;
						case 2: nbuf[e++]='o';break;
						case 3: nbuf[e++]='#';break;
						default: nbuf[e++]=' ';
						}
						switch (y) {
						case 0: nbuf[e++]=' ';break;
						case 1: nbuf[e++]='.';break;
						case 2: nbuf[e++]='o';break;
						case 3: nbuf[e++]='#';break;
						default: nbuf[e++]=' ';
						}
					}
				}
				if ( write(pfd, nbuf, 896) != 896 )
				error_exit(1,"modifying player executable");
				printf("written startup-logo\n");
			}
		}

// Tux Much

//MT	(int)answer[0]=128;
//MT	(int)answer[1]=192;
//MT	(int)answer[2]=1;
//MT	(int)answer[3]=8;
//MT	(int)answer[4]=128;
//MT	(int)answer[5]=0;
//MT	(int)answer[6]=0;
//MT	(int)answer[7]=0;
//MT	(int)answer[8]=32;
//MT	(int)answer[9]=0;
//MT	(int)answer[10]=0;
//MT	(int)answer[11]=0;
//MT	i=findoffset(lfd,answer,12);
//MT	i+=12;
//MT	printf("found Tux Much bitmap at offset %d; replace? [Y/N] ",i);
//MT	if ( fgets(answer,1024,stdin) != NULL ) 
//MT		if ( answer[0] == 'Y' || answer[0] == 'y' ) {
//MT			if ( lseek(lfd,i,SEEK_SET) != i )
//MT				error_exit(1,"Seeking in primitives.bin");
//MT			printf("bitmap filename : ");
//MT			if ( fgets(answer,1024,stdin) != NULL ) {
//MT				answer[strlen(answer)-1]='\0';
//MT     			ifd = open(answer, O_RDONLY);
//MT        			if ( ifd == -1 )
//MT					error_exit(1,answer);
//MT        			if ( fstat(ifd,fdstat) == -1 )
//MT					error_exit(1,answer);
//MT				if ( fdstat->st_size != 4100 )
//MT					error_exit(1,"file incorrect size");
//MT	
//MT				if ( read(ifd, buf, 4100) != 4100)
//MT					error_exit(1,answer);
//MT        			close(ifd);
//MT				e=0;
//MT				for (i=0;i<32;i++) {
//MT					for (j=0;j<64;j++) {
//MT						x=buf[4+j+(i*64)] & 15;
//MT						y=(buf[4+j+(i*64)] >> 4) & 15;
//MT						switch (x) {
//MT						case 1: x=2;break;
//MT						case 2: x=5;break;
//MT						case 3: x=7;break;
//MT						default: x=0;
//MT						}
//MT						switch (y) {
//MT						case 1: y=2;break;
//MT						case 2: y=5;break;
//MT						case 3: y=7;break;
//MT						default: y=0;
//MT						}
//MT						nbuf[e++]=(y << 4) | x;
//MT					}
//MT				}
//MT				if ( write(lfd, nbuf, 2048) != 2048 )
//MT				error_exit(1,"modifying primitives.bin");
//MT				printf("written Tux Much image\n");
//MT			}
//MT		}

	free(fdstat);
        close(pfd);
//MT        close(lfd);
	exit (0);
}
